package org.jboss.cache;

import static org.testng.AssertJUnit.assertFalse;
import static org.testng.AssertJUnit.assertTrue;

import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

/**
 * Tests restart (stop-destroy-create-start) of CacheImpl
 *
 * @author Bela Ban
 * @version $Id: TreeNodeTest.java 4444 2007-08-28 14:40:21Z jason.greene@jboss.com $
 */
@Test(groups={"functional"})
public class TreeNodeTest
{
   CacheImpl<Object, Object> cache;

   @BeforeMethod(alwaysRun = true)
   public void setUp() throws Exception
   {
      cache = (CacheImpl<Object, Object>) DefaultCacheFactory.getInstance().createCache();
   }

   @AfterMethod(alwaysRun = true)
   public void tearDown() throws Exception
   {
      cache.stop();
      cache.destroy();
   }

   public void testChildExist() throws Exception
   {
      Object key = 1;
      cache.put(Fqn.fromString("/a/b/c"), key, "test");
      Node<Object, Object> node = cache.get(Fqn.fromString("/a/b"));
      assertFalse(node.getChildren().isEmpty());
      assertTrue(node.getChild(new Fqn<String>("c")) != null);

      Fqn fqn = Fqn.fromString("/e/f");
      cache.put(fqn, "1", "1");
      node = cache.get(Fqn.fromString("/e"));
      assertFalse(node.getChildren().isEmpty());
      assertTrue(node.getChild(new Fqn<String>("f")) != null);
   }
}