package org.jboss.cache.passivation;

import org.jboss.cache.CacheImpl;
import org.jboss.cache.DefaultCacheFactory;
import org.jboss.cache.config.Configuration;
import org.jboss.cache.loader.CacheLoader;
import org.jboss.cache.loader.LocalDelegatingCacheLoader;
import org.testng.annotations.AfterMethod;

/**
 * Runs a test against using delegated cache loader
 *
 * @author <a href="mailto:{hmesha@novell.com}">{Hany Mesha}</a>
 * @version $Id: PassivationToLocalDelegatingCacheLoaderTest.java 4444 2007-08-28 14:40:21Z jason.greene@jboss.com $
 */
public class PassivationToLocalDelegatingCacheLoaderTest extends PassivationTestsBase
{
   CacheImpl delegating_cache;
   CacheLoader cache_loader;

   @SuppressWarnings("deprecation")
   protected void configureCache() throws Exception
   {
      delegating_cache = (CacheImpl) DefaultCacheFactory.getInstance().createCache(false);
      delegating_cache.getConfiguration().setCacheMode(Configuration.CacheMode.LOCAL);
      delegating_cache.create();
      delegating_cache.start();
      cache_loader = new LocalDelegatingCacheLoader(delegating_cache);
      // setCache first ...
      cache.getConfiguration().setCacheLoaderConfig(getCacheLoaderConfig("", "org.jboss.cache.loader.LocalDelegatingCacheLoader", "", false, false));
      cache.setCacheLoader(cache_loader);
   }

   @AfterMethod(alwaysRun = true) public void tearDown() throws Exception
   {
      super.tearDown();
      delegating_cache.stop();
      delegating_cache.destroy();
   }

   public void testLoadAndStore() throws Exception
   {
      //TODO intentional overload since this test does not pass
      //http://jira.jboss.com/jira/browse/JBCACHE-851
   }

}
